

use strict;

open (FD, $ARGV[1]) or die "Could not open param file";
my %params;
while (my $line = <FD>)
{
	chomp $line;
	my ($param, $val) = split("\t", $line);

	$params{$param} = $val;
}
close (FD);

open (FD, $ARGV[2]) or die "Could not open flag file";
my %flags;
while (my $line = <FD>)
{
	chomp $line;

	$flags{$line} = 1;
}
close (FD);

my $mono = '/usr/local/bin/mono';
my $exe = $ARGV[0];

my @map_args = ('Config', 'HistoneName', 'RnaSource', 'Tissue', 'LocusFileName', 'MapFileName');
my $map_arg_string = join(" ", map { "-$_ $params{$_}" } sort @map_args);

my $map_cmd = "$mono $exe -Mode CorrelationMapBuilder -Stage RunPipeline $map_arg_string";
print "$map_cmd\n";
system($map_cmd);

my @prediction_args = ('MapFileName');
my $prediction_arg_string = join(" ", map { "-$_ $params{$_}" } sort @prediction_args);
if ($flags{'UseGenes'} == 1)
{
	$prediction_arg_string .= " -UseGenes";
}

my $link_file = $params{'MapFileName'};
$link_file =~ s/.tsv/_links.tsv/;

my $link_cmd = "$mono $exe -Mode PredictLinks $prediction_arg_string -OutputFile $link_file";
print "$link_cmd\n";
system($link_cmd);

my $target_file = $params{'MapFileName'};
$target_file =~ s/.tsv/_targets.tsv/;

my $target_cmd = "$mono $exe -Mode PredictTargets $prediction_arg_string -OutputFile $target_file";
print "$target_cmd\n";
system($target_cmd);

my $element_file = $params{'MapFileName'};
$element_file =~ s/.tsv/_elements.tsv/;

my $element_cmd = "$mono $exe -Mode PredictElements $prediction_arg_string -OutputFile $element_file";
print "$element_cmd\n";
system($element_cmd);

my $browser_file = $params{'MapFileName'};
$browser_file =~ s/.tsv/_track.bed/;

my $browser_cmd = "$mono $exe -Mode BrowserTrackFromMap $prediction_arg_string -OutputFile $browser_file";
print "$browser_cmd\n";
system($browser_cmd);


